/*
 * Copyright (C) 2021 Anton Romanov - All Rights Reserved
 * You may use, distribute and modify this code, please write to: romanov73@gmail.com.
 */

package ru.ulstu.extractor.service;

import org.springframework.stereotype.Service;
import ru.ulstu.extractor.model.Author;
import ru.ulstu.extractor.repository.AuthorRepository;

import javax.transaction.Transactional;
import java.util.Optional;

@Service
public class AuthorService {
    private final AuthorRepository authorRepository;

    public AuthorService(AuthorRepository authorRepository) {
        this.authorRepository = authorRepository;
    }

    @Transactional
    public Author findOrCreate(Author author) {
        Optional<Author> newAuthor = authorRepository.findByName(author.getName()).stream().findAny();
        if (newAuthor.isEmpty()) {
            return authorRepository.save(author);
        }
        return newAuthor.get();
    }
}
